close all;
clear all;



obj = mmreader('C:\Users\sharon\Desktop\out.avi');
numFrames =200; 
frameRate = get(obj, 'FrameRate');
vidFrames = read(obj,[1,200]);
Options=struct('ScaleUpdate',1/1.2,'Resize',false);
 
FilePath='C:\Users\sharon\Desktop\semester project\EE7700_project_Jing Chen&Shaoming Chen\code\haarcascade_frontalface_alt2.mat';   
TrainDetector=GetTrainDetector(FilePath);
indexoframe=1;
for k=3:200
    if (k==3)
        detect_flag=k;
        
        img = vidFrames(:,:,:,k);img=imresize(img,[400 400]); figure(1);subplot(1,2,1);imshow(img);
        img=img(:,:,1);[height,width]=size(img);
        % Get the integral images
        IntgImg= IntergralImages(img,Options);
        face = VJFaceDetection(IntgImg,TrainDetector,Options);
        %show face
        [num,index]=size(face);
        if num>=2
            comb = Simp_combi(num,2);
            th=sqrt(sum((face(comb(:,1),1:2)-face(comb(:,2),1:2)).^2,2));
            if th<50
                face=mean(face);
            else
                index=find(th>50);
                face(1,:)=face(comb(index(1),1),:);
                face(2,:)=face(comb(index(2),2),:);
            end
        end
        if isempty(face)

        else
            rmin=face(2);
            rmax=face(2)+face(4);
            cmin=face(1);
            cmax=face(1)+face(3);
            wsize(1) = abs(rmax - rmin);
            wsize(2) = abs(cmax - cmin);
        end
        
        I = vidFrames(:,:,:,k); I=imresize(I,[400 400]);
        for r= rmin:rmax
            for c= cmin:cmax
                I(r, c,1) = 255;
            end
        end
        figure(1);subplot(1,2,2);imshow(I);
        movie1(indexoframe) = im2frame(uint8(I));
        indexoframe=indexoframe+1;
        
        hsvimage = rgb2hsv(imresize(vidFrames(:,:,:,detect_flag),[400 400]));
        huenorm = hsvimage(:,:,1);
        % scale to 0 to 255
        hue = huenorm*255;
        hue=uint8(hue);
        % Getting Histogram of Image:
        histogram = zeros(256,1);
        for i=rmin:rmax
            for j=cmin:cmax
                index = uint8(hue(i,j)+1);   
                histogram(index) = histogram(index) + 1;
            end
        end
        W = [wsize(1),wsize(2)];
        L = [rmin,cmin];
    else
        %camshift for tracking
        I = vidFrames(:,:,:,k); I=imresize(I,[400 400]);figure(1);subplot(1,2,1);imshow(I);
        [W,L,cmin, cmax, rmin, rmax]= mytestcamshift(W, L,I);
        for r= L(1):(L(1)+W(1))
             for c= L(2):(L(2)+W(2))
                 I(r, c,1) = 255;
             end
        end
        figure(1);subplot(1,2,2);imshow(I);
        movie1(indexoframe) = im2frame(uint8(I));
        indexoframe=indexoframe+1;
    end
            

end
movie2avi(movie1,'tracking.avi','fps', frameRate, 'compression', 'None');



